#
# Stroika ChangeLog
#
Date		Changer		Log Message

12/11/92	LGP			**************************************************************************
						GIVE UP!!! At least for now. Giving it all over to Sterl, while I go
						look for work, and try to pay Uncle Sam.
						**************************************************************************

07/10/92	LGP			Nearly totaly rewrite of the file stuff. Sadly its all broken now, but I think the
	-					Mac version is close to working again. I belive I now have a MUCH improved design.
07/08/92				Anxious to show to sterl, tom, and kdj. Also, wanted to get it working well enuf to
						get PCXLate working on the mac - that was the original impetus for the re-write.
07/07/92	LGP			Worked with Simone on PC port. On the third(Friday) redid Shape stuff using
	-					ReferenceCounted stuff, and neat new application of object slicing to implement
07/03/92				inheritance with envelopes (possible paper topic?). Worked on PCXLate - almost
						working on the mac - AutoGen/MapFiles work - but trouble with Files on mac leads
						me to begin yet another rewrite - then get back to PCXLate - should work fine
						then. Close to having templates work on PC, I think. Probably same with gcc.
						Spent 07/07 with sterl after his vacation doing lots of misc stroika changes/cleanups.
						Worked on ReferenceCounted. Added RoundUpTo () math util. Generally tried to knock
						easy things off of TODO list. (Renaming Seperator.hh/cc to spell correctly).
07/02/92	LGP			Work with Simone on PC makefiles. Pretty close.
	-					A Bunch of file/class renames:
06/31/92					-	DoublyLinkedList				->		DoubleLinkList
							-	Sequence_DoublyLinkedList		->		Sequence_DoubleLinkList
							-	Sequence_DoublyLLOfPointers		->		Sequence_DoubleLinkListPtr
							-	Sequence_ArrayOfPointers		->		Sequence_ArrayPtr
							-	Strings.hh/cc					->		Strings.hh/cc
						These changes were motivated by desire to make naming more consistent, and slightly
						shorter so we did not exceed Mac filesystem limit of 31 characters.
						Moved Makefile.MoreProductions to new directory Etc.
						No longer use loaddump in Graphix/Foundation - it was not a signigicany speedup,
						and caused slowdown in lib stage (which we do every time we change anything in
						Framework - other tweeks to this script support).
						Moved String/Real declarations of different macro based containers to Stroika-Foundation-Globals.hh
						Where the declarations are needed in other files, explicitly redeclare there, and use #define protection
						(defined in Stroika-Foundation-Globals.hh) to avoid conflicts.
						Built Flex/Bison for AUX, and working on getting PCXLate working there. Almost got it working
						on the mac  -  the compiler bug that prevented us before seems to have vanished?
						Got new BC++ yesterday, and will test their new tempate support soon.
06/30/92	LGP			More work on Schnauser. Almost totaly have Foundation
						ported to A/UX-gcc. Had to make one fix to g++-includes 2.1
						- conditionally comment out definition of readdir in sys/dir.h,
						cuz of funny interaction with apples choice to have dirent.h
						include sys/dir.h, and how g++lib does its #include_next hack.
						Added a few new gcc bug defines. Renamed Strings.hhcc to
						String.hhcc. Got rid of ArrayOfPointers/DoubleLinkedListOfPointers
						from RCS directory. Working on PC Makefiles with Simone.
						Close to having that working, and so I must get PCXLate working
						under AUX.
06/29/92	LGP			More work on Schnauser. Work on getting makefiles working again - also finish fixing rcs dirs.
06/28/92
06/27/92	LGP			Worked on first cut of new program Schnauser, and looked over RS/Graf stuff.
   -					Got most of Stroika Foundation to compile; and testsuites run under AUX. Still
06/22/92				Lots of cleanups to do there, to get working well, and thats without
						templates. Tried templates for a while, and fixed many of my own problems,
						worked around some gcc problems, but some seemed intractable. Would post them
						or mail bugs etc to guy at apple who did port, but I still havent' gotten mail
						working right!!!
						Simone started writing scripts/makefiles for PC/BC++, and will help with DOS
						port.
06/21/92	LGP			Porting to AUX, Big disk crash, and a weeks trying to recover. Had to rebuild RCS database.
06/11/92				Lovely.
06/10/92	LGP			Did Release 1.0d15, and wrote up release notes. Worked mostly on porting stuff to AUX, and getting
   -					that properly set up, esp using gcc. Worked on debugging PC port of Foundation classes.
06/04/92				Now I suspect code in Memory for patching ends of alloced memory for portability problems to PC.
  						Ordered upgrade to BorlandC++ 3.1. Should get betas of their new products.
  						Added more container class stuff, like Bag/Queue. Changed Array to use size_t instead of UInt32.
						Lots more - see ReleaseLog.
06/03/92	LGP			I hardly remember. Worked on pixelmap stuff, and read/write different X based formats, and
   -					now read/write and do PixelMapFromData () in a platform indepenedent manner (I hope).
05/03/92				Started developing code size hack for mac - great size optimization - same technique should
  						work for UNIX, but harder to implement, and different for each object file format/OS.
						Tom started working on Docs. I worked on templated new stuff for Container classes. Getting that
						ready for prime time. Somewhere in there I probably spent time getting ready for anoyher bakeoff
  						release. That went badly, and Marcam decided against using Stroika.
						Worked on cleaning up minor points of interface, to make it look more polished - thats a recurring
						theme amoung people whose see/use Stroika.
05/02/92	LGP			Lots of minor hacks to get ready for release on 5/1 for marcam bakeoff, including our
   -					own quickie - one night - implementation of it. Also, sterl fixedup SplitterView. I
04/21/92				impelented OptionMenu properly, and changed semantics of PopupMenu to be closer to what
						Motif means by this. Worked very unsuccessfully to debug problems with trackpress in widgets
						and subeventloops.
						Spent last week cleaning up PixelMap stuff, and doing hack read/write/codegenertion, and
  						getting bitblitter to be fast enuf. Also, Made colored tiles work. Did palletMgr extension
						to make creating colored tiles more easy. This comming week or two will be devoted to finally
						fixing up/cleaning up pixelmap stuff. Got pbmplus from kdj and will look at it. Use that to
						figure out what formats to support, and their definitions, etc... (added PixelMapEditor
						application).
04/20/92	LGP			Cleanup mode for a couple of weeks. Got rid of Bordered::CalcThickness(). Made stroika POSIX
						complaint - trouble spots not fully resolved are GetCurrentTime() and our version of Xlib isnt
						POSIX complaint - used caddr_t - and so we had to hack workaround that. Did quickie PixelMapEditor
	   					application as testbed for Pixel read/write and editing stuff. Also, nice demo program. Perhaps even
	   					useful in its own right, though most of it should be incoporated into Emily.
	   					Gonna spend next few days fixing up menus / desktop /etc and related code. Works only partially, and
	   					nows a good time to fully debug/implement.
04/17/92	LGP			Lots of misc bug fixes, and cleanups, including Scrollable Text, and better motif style
	-					popup menus, and PixelMapEditor. Worked aroound bugs with PixelMap stuff so we could get this
04/10/92				Workign acceptably. Also, Did inverse table CLUT impleamntion, and some caching to make Stroika
						bit blitter perform acceptably. Lots of stuff to get ready for Fridays release 1.0d11 for Marcams
  						bakeoff.
04/09/92	LGP			On mac, cleanup and better organization of scripts - put them into Stroika distribution.
	-					Did makeConfig script. Tested all apps on mac, and got working on macplus. All testsuites
04/07/92				(well most) compile and work. Similarly for UNIX. Cleaned up scripts, and made sure all the
						apps work. Getting ready for a realease. Cleaned up MotifOSControls - getting rid of magic view there,
						and added Reordering support for X Windows for Widgets in View - not a great place, but
						it seemed like the only possible place to make the hack. Now widgets have the right front-to-back
						ordering. Also, Working on putting hack into view so that EVERY non-leaf view will build its own widget, so
						that we will get widget clipping working better (there seems no way to really get this to work 100% properly.
						There just isn't any real control given over clipping a particular widget - you seem to have to create surrounding
						X windows to eclipse parts of it). Should be doing a release tommorrow. Lots of misc cleanups. Hopefully Tom Kent
						will cleanup mac/motif dialogs tonight which should make things look nicer.
						next on my list after Full clipping support is Scrollable Text, and other text bugs. Must get clipping working
						right though, to have a good chance at fixing ScrollableText.
04/06/92	LGP			On mac work on performance - did profiling - saw trouble on mac was menu::SetEnabled(),
	-					and fixed by created hash table to map directly from command numbers to MenuItem*.
04/03/93				Seems to have helped alot, but need to do another build to see.
						Worked on PC port, and have another bunch of files to merge (still just getting
						bottom two layers to compile - mostly that is just writing templates instead of
						macros).
						Worked alot of bitblit/graphix stuff under X. Kept CLUT/visual with Tablet, and
						now bittblitter does inverse color map (for some cases - not done well) for bitblits.
						New override of BitBlit in tablet (instead of seperate functions - they are gone).
						Now under X it either directly calls XCopyArea (instead of old XCopyPlane) or BitBlitter to
						make a pixmap that would be XCopyArea' able. Hassled with Xlib pixelmap support.
						Starting to wonder how useful it is to use!!! Does not support pixelmaps of
						depth 2, I think. Totally undocumente, and unclear from the source.
04/02/92	LGP			Tested new bitblit stuff, etc in Emily. All the view optimizations and so on seem to be
  						working fine. Also, Worked on more template support. Should be pretty close to being able
  						to compile first two Stroika layers on PC, and test out Foundation, and templates.
						PixelMapEditor class seems to be working well, and fixed linger bugs with PixelMap stuff
						going back and forth between Pixmap and XImage representations.
04/02/92	LGP			Way of of date - sorry. Last few days working on graphix stuff, including new bitblitter.
						Finally got rid of View::Focus () stuff. Hope it still works :-). Thoguh I havent
						kept this up to date, I have been doing a good job keeping rcslogs uptodate.
02/28/92	LGP			Implemented CurrentIndex for SequenceIterators.
	-					Worked alot more on menus stuff - back ported all to unix when everything is a view.
02/27/92				Worked on Misc changes from TODO from NY trip.
						Cleaned up UNIX makefiles so can build outside stroika hierarchy more easily.
						Got rid of StringGrid.
02/26/92	LGP			Went to Marcam.
02/25/92	LGP			Worked on menu stuff.
02/24/92	LGP			Went to NY with Sterl to to meet with dad, and friends about Stroika.
02/23/92	LGP			Minor changes - fixed title of pathname selectors, and fixed to many invals bug with expose
						proc in ExposeProc callback in window.cc (motif).
02/19/92	LGP			Got everything building on mac, while sterl re-did emily dialogs under motif using his
						new dual representation stuff. About to do final remerge, and then hopefully release.
						Talked to bob and will order Borland tommorrow, and get PC back soon to start port.
						Go to marcam tommorrow and try to port to sun - worried if they have motif libs?
02/19/92	LGP			Fixed bug with EventHanlder chain and activates - use more Xt based stuff and less of our
						overrides of X event processing. Made client messages like deletewindow, and our private one
						to implement about box work nicer. Also, applied same technique to Update events, and now
						have VERY LITTLE FLICKER. One of the main troubles with Accelerators with menus (maybe the
						only trouble) is that we dont deal with keyboards right. Will fix after release. Lots of work
						doing cleanups for release. Sterl working on allowuing non-zero margins and fixing CalcDefaultSizes,
						and useing new emily feature to define sizes differently for different interfaces to cleanup emily,
						and make things look more motifish.
						Hoping to do a relase tonite, or early tommorow.
02/18/92	LGP			Worked on getting out a release - doing lots of compiling, and minor cleanups. Still not
						ready todo release. Spent day at Marcam. Reviewed status there, and talked about Booch Lib.
						Spent alot of day writing up report on Booch lib.
02/17/92	LGP			Worked on iconic menu stuff under X, and also accelerators. They now display in menus, but
						do not behave properly yet. Also, we must generalize our representation of accelerators
						for motif, I think. Also, worked on portable representation of versions for Stroika and
						various apps. Still must test on mac, but works on UNIX. About to do about box for X, so we
						can keep track of app versions easier.
02/14/92	LGP			Mostly working on Menu stuff, primarily on the mac, although I finally got to try to do
   -					ButtonMenuItems under X. Not surprisingly, it was a nightmare. The obvous thing to do is
02/12/92				use a DrawnButton, but rowcolumns (aka menus) insist on the menu items being from amonng
	  					a handfull of classes, none of which make sense for me to use. I'll find some hack eventaully
						but this really stinks. Other than that, the menu stuff is improving more slowly that I hoped,
						but is making good, steady progress. I broke up the stuff that was in MenuOwner into PullDown/PopupMenu
						files, and MenuBar, and Accelerator, and MenuTitle. Lots of minor cleanups, many relating
						to the fact that we no longer have multiple kinds of menus (distingusing native vs portable)
						and so we can cleanup a bunch of code that dealt with duplicate representations. Also, made more
						portable the menu MDEF callback stuff, so it can be retrofitted to work with motif (only trouble
						now on the motif end - not with our stuff). Sterl merged tonite, and I am getting it all to compile
						right on UNIX, and back on mac again - big merge.
02/11/92	LGP			On X, worked on graphix stuff - always keep PixelMap around for Tiles (for now just on X, but should
						be true for mac too) and therefore on X, we now have the clut handy. Then we COULD use it in Tablet
						when drawing, but we need access to current color table (still reading how todo that).
						On mac, mostly worked on trying new apple compiler. Seems to have NO NEW BUGS, and a few anoyying
						ones fixed - background compiles work pretty well. Very few crashes. Also, finaly got rid of cruft
						classes in Menu.hh, and can now finally focus on simplifying that one class. Soon todo: make it sufficiently
						portable in interface for overriding MDEF that subclasses like TearOff will work on UNIX. Also, Actually do
						the work (magic time) to get this class to really work under UNIX. Work on clipping soon. Maybe give cut
						at Stackbased clipping idea in view? Visited bob in hospital - another Stroika victim, bites the dust!
02/10/92	LGP			Fixed bug on Carls machine at marcam (bug with missunderstanding about graphixmodes/function/stipples
						with drawlines in X - docs apparently self-contradictory). Also, Got new ETO from Apple, so trying new
						compilers, etc.. hopeful. Backported to UNIX.
02/10/92	LGP			Worked a bit on menu stuff in AM, and then went to Marcam. Also, worked on PalletManager, and Tiles
  						(tiles on X must keep CLUT - even if pixmap is gone... Maybe always keep pixmap?)
02/09/92	LGP			Didnt get much done cuz of guests, but work mostly on mac menu stuff and general menu cleanups.
   -					Did all menuitem stuff so pretty happy, and mostly thru Menu - so were down to just 1 class
02/07/92				on X, and 2 under UNIX - merge down to one, and cleanup more. Then try to get custom stuff working
  						under X. Talked alot about what to do about menubars, but still not too happy.
02/06/92	LGP			Backported to mac and gave sterl a version to work on. Didn't have time to
						go to Marcam to fix bug on Carls machine. Do that on Monday.
02/05/92	LGP			Dropped version at marcam and verified that bug on Carls machine still exists.
						Worked with Tom Kent on Augment.
02/04/92	LGP			Helped sterl a bit with motif textedit fixes, and worked on cleaning up menu code. Now close to having
						just 1 menu class, and from bottom up have realize stuff working pretty well. Played with Emily, and
						did monkey testing, and fixed some minor troubles. Doing nodebug build now, hopefully so we can bring
						to marcam tommorow. Right now also doing mac build to be sure menus still OK (and to make some changes).
02/04/92	LGP			Worked on cleanup of menu class - esp realization stuff. Also, fixed worked around bug with MotifOSControls
						to make TrackPress wait til end of buttonup event before returning (fixed some textedit bugs).
02/04/92	LGP			Sent in a copy of last Saturdays build with Simone to try on Carls machine and see if it works OK, or
						if it still has that weird XOR bug. Sterl working on TE. I added IsNativeMenu () to MenuItem for mactoolkit
						as step towards being able to get rid of the distinction between "standard" and "custom" menus -
						now we should be able to "auto-detect". Still needs lots of work but mostly on mac, and Sterls using that.
  						Made Sequence Append/Prepend non-virtual since we really should do any optimizations for this case in
						InsertAt () anyhow. Also, made IndexOfSubSequence take const ref arg.
02/03/92	LGP			Worked on cleaning up the Menu code. Working bottom up, and first cleaned up menuitem. Broke it into
						seperate files for each kind (eg StringMenuItem, etc) and added intermediate classes for native/portable,
  						and most derived classes to actually instantiate (instead of #defines or typedef). Worked on realization
						so they can be added/removed at will.
02/01/92	LGP			Spent an hour putting in hacks in Window to do erases. Easy - just clone region code from Tablet, and
  						do paints of pattern which is background from XtGetValue(xtbackground). Soon, when I fix tiles, I can
						use Tablet directly. Had to hack around erasign menus cuz they are not yet views, but will be fixing that
						soon. NOW STROIKA GRAPHIX IN EMILY LOOK GOOD! No known display glitches, but problem carl had (I havent
						seen it anywhwere but his machine), and was trouble dragging textedits - I will have to play with that. SB
  						easy.
01/31/92	LGP			More cleanups of the display stuff. Worked on trouble with configurewindows, and mainview window resizing
						other windows. Trouble was they should be created with XtAppCreateShell, NOT XtBuildWidget (Simone is the
						one who tipped me off). Then the trick was getting them to be visible/invisible when I wanted. They came
						up visible by default. Only trick I could find was setting XtMappedWhenManaged to false before realizing
						them. That is SORT OF what the boolean is for, but these guys ARE NEVER MANAGED, so I'm not too sure my
						usage is safe. When I get net stuff straightened out, thats a good question for a netpost.
01/30/92	LGP			Did lots of motif reading, and finaly got up the guts to try patching widgets Expose procs. After several
						hangups, I FINALLY GOT IT WORKING. It still needs ALOT more work, BUT Emily now behaves VERY well,
  						in its graphix. The main graphix problem afflicting Emily now, is poor handling of background tiles, which
						I will address tommorrow. Then code cleanups, working on portability/safety of expose proc patch.
01/29/92	LGP			Spent several hours getting sterls changes to Shell to work again. Very unhappy about his change of
						inheritance of Shell/ImplemenationShell stuff - always a bad idea to warp inhertance hierarchy to save
  						a few lines of code (though his criticism that my implementation of delegation is bulbous is valid, I
						feel strongly that is a minor consideration compared with the clarity of the inheritance structure).
						Sterl read up on motif stuff in our new volume VI book, and told me to do realize before managing for
  						composites, and to use DrawingAreaWidget instead of BullitenBoards. Seems to work fine, but really didn't
						seem to solve any big problems (nice though that when looking for bugs, we can avoid purusing the
						bulletinboard code, since its a real rats-nest).
						Used gadgets in the menus (for the menu items). Should be faster, and cheaper, and seems to work just
						as well. Formed a small bug list for Emily for sterl. tarting reading source, and docs about update mechanism.
01/28/92	LGP			Fixed bug with menu labels getting lost (I introduced it accedentally by removing a Sterl workaround). I
						fixed the problem properly by adding an idle task to do SetupMenus in application.
01/28/92	LGP			Moved MousePress/Track stuff from Application to Desktop. Also, move Desktop construction to Desktop::Get()
						method instead of arg to Application. Allow for overriding the assertion proc.
01/28/92	LGP			Started moving more stuff out of application - taking advantage of new EventHandler architecture. Moved
						ClipBoard support out, and made more reasoanble how you install your own clipboard object. Soon
						to move out mouse/key stuff from application cuz I want to work on Menus in windows, but that stuff is
  						tightly tied together - tough to start anywhere...
01/27/92	LGP			After 1/2 dozen hours work I tracked down the bug with creating a pixelmap for the grid in Emily. Trouble
						was I simply reversed X/Y parameters to XPutPixel. But, it points out the value of range checking - what a
						waste of time. Along the way to help be debug the problem, I made even more important progress - I added
						trailers ("gaurds") to memory allocations, and added checks for these in ValidateHeapAllocations. That was
  						very helpful debugging the XPutPixel problem. Also, I cleaned up the PixelMap code for X, quite abit since
						I was fully convinced it was one of the zillion magic parameters I set that was causing the thing to scribble
						in the wrong place. As a side effect of my furthered understanding of endianness, and how to deal with that in
						PixelMaps, I added a new family of overloaded rouintes (PixelMapFromData ()) which are to be used in constructing
  						PixelMaps in a portable format. Normal constructors assume data layed out in a native format.
01/27/92	LGP			In response to two of Carls major bugs (really same thing) we now support ICCM WM_DELETE_WINDOW cleint message,
						and treat it as if the user did a eClose comamnd from the menu. Works nicely.
01/27/92	LGP			Meet at marcam, and showed Carl latest version. He gave me buglist, and I will concentrate today on
						nailing the easist of his bugs first, and then soon to start major update/display work - and maybe writing our
						own widget.
01/22/92	LGP			Work on number text, and number formatting. Fix bug with get/put file dlogs. Worked on scrolling.
   -					Worked on realization, and made widget building resileint to arbirary realize/unrealize pairs. Tried
01/26/92				first to get cloning to work, the discovered Marcam Canada's idea unworkable, so had to abandon. Now we keep
						our own info in each subclass to update real widget on realization (sad approach, but best I know of, for now).
						Also, made optional construction of magic view so we can use oscontrol stuff in menus (where sometimes widgets peek
						at their parents). Read up on Xt methods, and widget internals, and preparing to do my own widget, and/or somehow fix
						update/display problems. Now I think thats about the highest prioriry. Also, thought about menu/mainviewmenu window idea.
						Deleted some unused/half implemnted files/classes to avoid confusing marcam as to what IS in stroika - need to find
						some better way to keep track of these "future projects".
01/21/92	LGP			Cleanup Container class stuff since marcam really starting to use it. Got rid of vistigel design
						peices (eg ++, it.More), and added sorting for sequences. Added GDI/Toolkit layer versions of OSInit,
						and OSConfig (though we still need to move more stuff in OSInit/OSConfig up layers).
  						Cleanup sample apps. Fixed bug with TicTacToe - now works right on UNIX - trouble was needed Sync call
  						in Window::Update ().
01/20/92	LGP			Worked flat out for a week trying to get Emily working acceptably (ie usably) under UNIX. More
   -					or less succeeded, and 1/20 had demo at Marcam. During this period we largly got rid of global coordinates,
01/14/92				Broke out Enclosure into seperate calss, and TabletOwner from Panel. No base class for MouseHandelr.
						Much, much more....
01/13/92	LGP			Implemented first cut at font support for Unix - somewhat working. Also, started break up of panel stuff
						and elimination of global coordinates. Also, implemented Set_Array, and used in font iterator implementation.
01/10/92	LGP			Implemented PathNameSelectors and got fileio working in the dialogeditor. Tested under mac/unix
						with and without debug. Went in to marcam for demo.
01/09/92	LGP			Worked on a whole lot of things centered around getting the DialogEditor up and working under
						motif. Debugged more troubles with update mechanism - will require major code cleanups - getting
						rid of global coords - to fix. Also, need cloning to work for motifoscontrols - close to this too.
						Not enables of most controls working and fixed a bevy of minor bugs with motif versions of widgets.
						Now we can edit text. Tried to get Emily up and working, but compiler bugs, and the knowledge of
						missing features (popupmenus, and custom menus) stopped me - try this weekend. Did get dialog editor
						up and working under motif. Can move widgets, double click - lots of display glitches however - need better
						regions, clipping, and for widgets to go where I say!!!
						Came up with good strategy for cliping motif widgets (have an owning widget all within motifoscontrol,
						that gives us lots of stuff as widgets seem to peek at their parent for lots of GC related things).
01/08/92	LGP			Spent most of day fixing 1/2 dozen or so subtle bugs throughout Stroika. Align() macro was broken
						because of compiler bug (report - I have a bunch for apple and hp that I havent sent yet). Also,
						ReAlloc was buggy - copying FROM past end of old memory (pretty safe on mac, but sloppy, and fatal under UNIX).
						Also, fixed region bug that was hampering Window::Update () stuff (operator*- check other similar routines for
						the same bug!!!). Merged in more changes from Sterl,
						and made breif attempt to get Emily up - will do that tommorrow.
01/07/92	LGP			Redid EventManger stuff so we can decentralize event processing, and used that a bit. Pulled update
						processing out of Application, and put it into Window. Did portable implemenation of UpdateRegion
						stuff but ran into some difficulties - subtle bugs with region stuff. Also, worked around a bunch
						of Region bugs in the Tracker stuff. Merged in more of sterls changes, and did first cut getting Emily
						setup and compiling - will get new version from sterl tomorrow, and will port that.
01/06/92	LGP			Got mac shell stuff largely debugged - still waiting for sterl to bootstrap dialogs so we can
						kill backward compatability. More importantly, I found the bug that was haunting me under X with
						XtResizeWidget(). The trouble was a race with chains of coord transforms and X realizing, and changing
						size of windows.
01/05/92	LGP			Fully merged new window stuff with what I had on UNIX, and got it all working again. Also, have
						TicTacToe, and most other demo programms now working(liming along) under X. Have resize of a window
						by user being detected, and views changed size (under X) - was hard - and still a mystery over
						why XtResizeWidget would resize the widget, but XtSetValues would not. Lots of cleanups of the window/shell
						stuff. Did cut at textedit keystrokes but it didnt work. Staring another backport to mac to give to sterl
						tommorrow.
01/03/92	LGP			Still have trouble with regions - gona work on the region testsuite to try and resolve them better.
01/02/92	LGP			Went to marcam and demoed what we had gotten done. Made good progress at night on
  						UNIX end getting DialogEditor working - cleaned up mouseclicks and fixed overflow
						bug with time. Worked on better interface to resources. Lots of work on mac on getting
						Shell/Window stuff in good shape, and have good designs for Panel/Tabletowner  starting
						to impelement. Also, working on Getting new interface to Dialog size/placement, and 
						making them use MainView. Tommorow will do merge with mac/unix, and try changes out under UNIX.
12/30/91	LGP		    Got rid of qNativeGUIAvailable and qNativeAvailable, and now use Toolkit #defines.
   -					Got mac version of new window stuff mostly working after sterl/unix merge. Works pretty
12/28/91				well both places (still more cleanup todo+palettes). Also, must fix bug with dialog editor pallet
						(I guess I merged sterls fixes wrongly). On UNIX, making good progress on native StringView, but trouble
						doing calcdefaultsize there???? Big part of trouble was different sized results with XtGetValues - did
						accessor support in MotifOSControl that should help that out in the future. Got a few more
						sample apps running - TicTacToe, and TextEdit. Seems that MPW_..RETURN_REF_VIRT_Lookup bug prevelent
						with TE stuff. Must work around that more fully. Also, got new mpw 2.1 based compiler. Found a few
						new bugs (REPORT SOON) but WAS ABLE TO GET IT TO WORK WITH LOAD/DUMP - SOON WE CAN GIVE UP
						ON 2.0 COMPAT - I HOPE!!! - Dying to do typedef inherited trick.
12/27/91	LGP		    Mostly worked on getting DialogEditor to work under UNIX, getting alerts to
   -					work, and the new window/shell architecture (got that working acceptably well
12/18/91				for now under mac and UNIX except for a bit more work on UNIX window hints, and
						Mac Pallet windoid.
						Also worked on getting more of oscontrol callbacks working.
						Got a "Get Dialog Info" dialog to come up on motif - and looked nearly
						right - biggest problem is layout wrong due to lack of font support - fix soon.
						Started wrapping includes with #ifndef wrappers around #includes - tough I find this
						style ugly, and obviously redundent, it appears to speed HP compile time - at
						probably others too - so its worth it...
						Survived (I hope) major disk crash (12/27) after hours of typing - hope I recovered all :-).
12/17/91	LGP			Went to marcam for ususal meeting. Then worked for a long time implementing
						shell stuff. Got something working somewhat on motif - good progress but a long
						way to go. Also, reverted to older style ar in makefile - slower, but fact I couldnt
						tell on a fail was too painful - look for better way.
12/16/91	LGP			Got xor working in graphix - required some tricker than I dont
   -					like (in Tablet::UseBrush). That needs some more thought. Got trackers working,
12/10/91				and proper dispatynd keystrookes. Dont yet do fake-events but very close
						(maybe just a couple lines of code in motifoscontrol). Major thing left to do
is window re-org - build class shell. Not quite sure how to go about this, but making a cut at it
today (12/17). Also, worked/workall the apps working on the mac after changes. Also, cleaning up comments
and putting in rcs stuff and standard headers. Also, getting rid of crap after #else and #endif as kdj tells
me this is NOT ansi standard (I wish I had a copy of the standard!).

12/09/91	LGP			Got a little more of textedit done - setting/getting text and length.
						Most of accessors sb fairly easy - but nows about time to do click/update
						stuff right. Also, add update / event mechanism override to list of questions for
						Bill Bennet or whomever.
12/09/91	LGP			Got TextEdit working. (trouble was size of edittext field caues X lib crash - 
   - 					Motif bug?). Changed kBadNumber to have some value for getting dailogeditor working,
12/05/91				But that is not the right thing to do. We probably have to get rid of it, or at least
						re-think it. Also, Found another hpc++ bug - in some cases _ at end of class name when
						you've done a mult inheritance mixin (and more) then get internal compiler error.
12/04/91	LGP			Got most controls but not text edit working - causes bad crash - x protocol
						error - tough to track down. Also, tried to make View class methods access
						more restrictive - fixed most places but finally had to give up - go back to
						it later this week. Sterl about to do merge and try to get dialog editor to build
  						on snake.
12/04/91	LGP			Got native Scrollbar, portable PixelMapButton, native Checkbox, native
  						RadioButton, etc working (really just building/displaying). Much work todo
						but much progress too.
						Also, started adding RCS headers.
  						Added String::ToC/P String calls.
						Re-genned hp kernel to play around with different disk cache sizes, and got
						interesting results. I think we need more memory. Usign 16 meg cache, we got
  						slightly slower rebuild of Stroika, but 33% speedup of links (60sec to 40sec),
  						and similarly for ar (60+ secs down to 25-35 depending on ar stragegy).
  						Ask brock how expensive more memory is?
12/03/91	LGP			Marcam visit. Then got MotifOSControl working pretty well and got
  						pushbuttons, and checkboxes to use them.
12/03/91	LGP			Made more progress on MotifOSControl - got pushbutton re-implemnented
						using it. Though, when I tried to do radiobutton, and checkbox with it,
						I realized that my approach of passing class names in the CTOR was inadequate,
						and I would have to subclass MotifOSControl for each control, and do the actual
  						create call there - still must work out how to automate and save code on that
  						whole process.
12/02/91	LGP			Redid realize support in view, and used new support in menus, and
						pushbutton. Get a bunch of mac portable controls working (at least displaying).
						Investigated update mechanism, and it seems hard to get to work the way
						we want.
12/01/91	LGP			Thanxgiving, and did very little. Worked on getting pushbutton to be
   -					properly sized. Trouble was parent was autoresizing after I resized.
11/27/91	LGP			Also, sped up build process by doing gross hacks to makefiles.
11/26/91	LGP			Marcam EXPO, and then read thru motif sources to learn about why I coulnt
						Get button to size the way I wanted. Then worked on makefiles and got big
						speedup on ar by doing direct access to subdir .os, but required a log of
  						makefile hacking to get dependencies right - not sure I like how it works
  						now, but how can you argue with improving ar from 3 mins to 1? Tried linker
						-X option to speed links, but it apparently had no effect?? Added filter
  						support to cmake shell script so I can filter out the stupid error messages
						CPP generates and start paying attention to the real ones - just say eg.
						setenv CMAKE_FILTER "fgrep -v warning" to get rid of warnings.
11/25/91	LGP			Marcam EXPO
11/24/91	LGP		    Got all the various apps build and run on HP, at least as well as on sun. Ran
   -					into only 1 serious compiler bug, but couldnt post it to the net cuz my postnews
11/23/91				wasn't installed right. Made progress on my graphix bugs and got pixmaps and tiles
						including some limited bitblits to work.  Still trouble with 8x8 pixel tiles. Seems
						to insist on reading crap past the end.... That is rowbytes of 32, no matter what
						I say??? Sterl got a pushbutton to build, though not quite properly under motif.
						I hacked build of white/black tile to work for now, but must solve above problems.
						Also, consider making build of tiles done my some color mgr object, like palettemgr.
						After some work, I no longer depend on gnumake and my scripts work on both suns and
						hps. Bring back suns tommorrow. Help sterl write-up presentation for Marcam tonite.
11/22/91	LGP			Worked on getting snakes setup. Got whole net based on snakes, and got uucp
   -					and news workign - sort of - cannot post. Got Stroika, and Small and Tiny to
11/20/91				build and work as well as on Sun. With some work I got Bap working too. Lots
  						of script changes to get rid of dependency on gnumake, and funky bourne shell
						on HPs. Also, found bug in Snake CC where nested classes break with -g turned on.
						Need -g cuz without, adb and xdb produce garbage stack traces. Still must do
						more work on graphix to make things look right. Still systematically getting
						each app to build and run as best as possible. Must workout presentation for
						Zed visit monday. Got tictactoe working somewhat - some bugs, but at least it
  						runs. HP C++ does order of .o ctors differntly than I like, so finally I think
  						were foreced to be more careful about this within apps too and have a common
  						include for all app globals - ugg...
						Came up with great design for layout/constraints - have simple language to specify
						algebraic constraints and do eqn solver to find positions - better approach than
  						constrain objects/functions cuz guarnteed termination - detection of over/under
						specification, and maximal efficeincy at runtime. Still need to convince sterl, and
  						Bob thought idea was overkill??
						Got PCXlate to work - tested.
11/19/91	LGP			Worked on getting the snakes set up.
   -
11/15/91
11/14/91	LGP			Lots more big time progress. Did ovals, and implemented shell windows, and
						got a view built and drawn - extended Small to have a doc, window, and view
						and got some graphix from the view to draw!!! Still must do update mechanism
						and then I should be able to port most of Test!!!
11/13/91	LGP			Got Stroika workign with CFront.
						Lots of break-thrus!!! Got cursors implemented and tested. Some design difficulties
  						in that we cannot just set the cursor, we must associate one with a window, but Sterl
						and I worked out a stragegy whereby that might work reasobably. We take advanage of
						input focus change messages to keep re-installing teh current cursor in the currently
						focused shell window. The low level mechanism for setting the cursor, and getting them
  						from resources is tested.
  						More importantly, I built a Tablet, called fillrect, and used a tile to do differernt
						fills!!! Fills did not work perfectly - difficulties using tiles - depth must match screen -
						but got working using stiples. Acceptable for now, but the real trouble is the way in which
						we allow specification of this stuff from Stroika, we must to some compicated conditional
  						work to see if we should be using a stipple or Tile to accomplish what the user asked for - the
  						details are still yet to be worked out. Re-enabled having asserts to a core dump. No longer happens
						often enuf to get in my face. Also, Tiny quits cleanly now - used to coredump on quit.
11/12/91	LGP			Went to marcam. Fixed up mac scripts to make work/builds there easier. Tried to get some
						stuff to build there. Check my pixmap changes havenet obviously broken things (yet?).
						Merge mac changes back (losts of NFS bug workarounds). Spent most of day at Marcam in contract
						negotiations. Simone visited Rational systems, and suggested I, or bob get in touch with them
						about Stroika. Fixed bug in ShapeAdornemt with order of construction - turned out that
						was reason we didnt work with CFront - they do order of construction differently - a problem
						we must deal with soon - but Sterl was sloppy in Adornment, and were lucky that ever worked!
						Same bug with Tracker.cc.
11/11/91	LGP			Got decent first cut at PixelMaps done, enuf to build testsuite and have it work.
						Still alot to be done there. Did a cut at Cursors. Sterl got Menus working
  						acceptably, so I will integegrate with him. Ported all to CFront.
11/08/91	LGP			Worked on backport to mac, and cleaning all source files, and script transfer tools.
						Helped sterl with new menu stuff, and got update pixmaps and regions working on mac again.
11/07/91	LGP			Got file stuff and (bob got pcxlate) and autogen, mapfiles tools working on UNIX.
						Worked on PixelMaps - worked on backport to mac, and merge, and scripts to make
						xfers easier.
11/06/91	LGP			Added support to memory manager to munge memory just before a free to flush
						out bugs with memory referecnes after being freed. Also, reorganized file
						stuff around FileSystem concept, and tried to move ifdefs inside each function
						and to reduce there number as much as I could (in file.cc).
11/05/91	LGP			Helped bob with file stuff, and did cleanups. Worked on PixelMap stuff. Met
						for several hours at Marcam.
11/04/91	LGP			Got most of newsfeed setup. Work hard on Pixelmap stuff, but very difficult problem because
  						X approach so different from what we want to support. Really brain-dead that they require
  						a client connection, and a drawable to specify an image, and the distinction between Pixmaps
						and Images is inconvienent but reasonable. Having a hard time understanding about visuals.
						Readding lots of example programs, including (most productively) interviews 2.6.
  						Wrote Color, and ColorLookupTable (maybe should do testsuites?). And did cut at headers
  						(especially documentating issues) on PixelMap.
11/01/91	LGP			Got Stroika ported to CFront, and implemented Regions for XGDI, and built testsuite for them.
						Regions in pretty good shape, and got decent code sharing for first cut - next project is
						PixelMap.  On Stroika port to CFront, never really resolved trouble with cpp - for now just
						pre-preprocess with gcc-cpp. Also, althogh test suites all worked - after some effort - still
						didn't get tiny up - but that was OK - problem was call to Tile stuff which we handed implemented - not
						quite sure why it wasn't a problem for g++ - but OH, well. Wait til I do tile to debug that stuff if
						need be. Also, fixup makefiles a bit more - add flags for gdb.
10/30/91	LGP			Got uucp up and working, and news on the way.  Got Tiny up and working. Worked on testsuites.
						(added new one for Doubly linked list - got sterl to fix bugs).
						Changed over to RCS from Projector. Got makes on Unix to work off bourn shell scripts for configuration,
						and got sun C++ installed, and configured for it. Ran into lots of trouble getting that to work, mostly
						cpp problems. Still not done. Worked with sterl on menu design for Motif. Reconfigured office so more
						room for sterl and I to work together.
10/21/91	LGP			Over the weekend and up til now, I had my sparc monitor die. Will mail back tommorow, and
						get new one wednesday, I hope. Rebuilding with motifGUI turned on, and trying to get things
						to link. A lot of work. Found a bug where g++ screws up with pure virutals. Easy workaround - just
						say virt x (){} instead of =0; Should be getting Cfront2.1 for sun tonite or tommorow.
						Worked with sterl til three rebuilding x/motif for protagoras, and building a stubbed motifGUI
						version of Stroika for the Sun. Got pretty close to linking Tiny, but not quite. Hopefully tommorow.
						Also, should get cfront2.1 from Sun for Sparc tommorow also. Then, if we have codegen errors
						with g++, we can work around them easily enuf with the sun compiler.
10/18/91	LGP			A couple of days shot helping sterl resurect is stroika changes, etc and hardware. Very
						bad business that. Tried calling 1/2 million people to get unsenet feed. Made 
						typedef size_t CollectionSize; and typedef CollectionSize SequenceIndex; Only really
						relevant for PC. Got motif code on sparc working pretty well - main trouble is that yuo
						cannot seem to create a widget without a parent, and then add it later. So sad. Major
						design problem - though I can think of workarounds, they to degrees default the seemless
						backdoor mechanisms we would like to allow (more preciesely, if we only create widgets at the
						last momement, getoscontrol cannot work so seemlessly on Motif!!).
						Got rid of SetTraversalDirection (), ToStart and ToEnd () from SequenceIterator.
						Worked on qMotifGUI defines in framework so I can add in code for working Tiny motif appl.
10/15/91	LGP			Rebuilt somewhat successfully on mac. Found sterls terminator. Taked to NFS people and the
						promissed a bugfix version by end of this week (all bugs fixed but MPW file update resource mod data
						bug). Goin to marcam - bringing tapes.
10/14/91	LGP			Merged in old Testsuite changes. Still must merge in bobs UInt64 test suite. Worked on makefiles
						and build scripts and fixed unix probs due to Sterl merge. Tried to make more sane bug declarations
						and test with all compilers, but mac 2.1 based compiler seems to have taken a nose-dive!
						Added argc/argv to Application constructurs, cuz will need for X. Also, warmed over motif
						example in ~lewis/test to the point where works with g++, and is pretty understandable. Very
						close to hacking that into Stroika (a few days) to get "Small" up and working. Still must get Sterls
						machine setup for him. Going to Marcam tomoorow for review, and to negotiate with Brock about
						contract. Also, worked on UUCP - got it working to osi-cis (ohio univ?). Tommorrow hopefully can
						get news feed from think! Met with beth marcus - she may be willing to hire bob to take over for
						me and sterl, and maybe to do PC port. Goin well ?
10/13/91	LGP			Got rest of Stroika library to build on Sparc. Had to hack a bit at the end. Still needs quite
						alot of work to get it to link, and remove many of the hacks. One trouble was window, and another
						was Menu. Both of these were impromely designed from a portabilty standpoint. Also, mucho hackos
						for lack of stream support. We really must get this fixed SOON! Lots of work on makefiles (never ends)
						especially on the mac, to make build process easier. Get disk from Sterl, and starting a merge.
						Looks like he implemented new string support. And tried new Invariant () stuff from Stroustrup.
10/11/91	LGP			During the last week and a half, I got alot done on the port. Most of my time spent
						setting up Sun/NFS/NIS/TELNET, etc. Still not really done well. Alot of time setting up
						makefiles, and build strategies. Alot of time (apx 40hrs) building motif and X for sun, and
						getting to work. Have Foundation reasonably well ported, and working on gettting upper layers
						to just compile with ifdefs. Lots of compiler bugs/features with G++ an issue.
						Great new idea for Strings on how to deal with no-delete problem, and much more! Sterl typed
						in today. Also, Sterl worked on adjusting inheritance with FocusItem stuff, and added LiveItem.
						Implemented but not very well tested KDJs ideas on iterators and closures. Will try to keep up
						with Changelog better in future... May try sleeping occasionally too.
09/25/91	LGP			Worked on PCXLate, and typed in lots of minor Foundation portability cleanups from
						the printouts I'd reviewed. Also, taked over with sterl the TODO stuff, and came up
						with some good ideas.
09/24/91	LGP			Shutoff shared strings. Work on CPlusLexer. Fix string compares. Cleaned up TODO file.
						Ran into compiler bugs so had to shorted names in Foundation and rebuild.
						Also, put kBadPathName into File. Put kPi/eulers number into Math, and used in Angle.cc.
						Redid algorithms in array to use ptr arith rather than array indexing.
09/23/91	LGP			Allow delete (Nil) for compat with E&S, and other libs. Sad.
09/21/91	LGP			Added Integer/bignum package, and bap test program.
09/20/91	LGP			Obviously lots of changes over last two months, but no time to keep track. Starting
						at Marcam on Motif port, and so doing a release to backup what we had
						before that (1.0d4).
07/24/91	LGP			Rebuilt projector database, and moved some files around from level to level, and
						re-organized slightly.
07/17/91	LGP			Made huge numbers of graphix fixes, and misc changes, and then my harddisk
						dies! Get latest from Sterl as he went on vacation, and tried to put stuff
						back from memory. Think I fixed bug where we crashed in Monitors cdev.
						Building release Stroika, partly cuz gona demo tommorow to people from Marcam.
07/09/91	LGP			Cancel utton support in DialogEditor (call SetCancelutton in gened code).
						xSetPort hack moved into itlit in stroika, and removed most remnants
						from CHMS (need to do etter). Fixed? TextEdit::InsertText (). roken months
						ago and never noticed (not used?). ESC utton supported as meaning cancel
						in class Dialog.
06/30/91	LGP			Removed restiction that PixelMaps had to have cluts (not totally deuged).
						Started implementing Shared Pictures (too expensive to copy them all the time
						in CHMS since the can easily come to a meg each!). Improved Application
						low memory handling support.
						Use more DoTRAP() inline wrappers to hide #if qCacheTrap stuff in one place.
						Also, fixed up loophole in Region stuff where people could modify
						a shared region. When sharing was added here, it was not careful enuf. If
						you have a peek routine that returns a const ptr to the iternal rep thats Ok,
						ut the getter does an Assure1Ref() and then returns the ptr to te internal rep,
						so we only change what we expected! This had ramifications thgouhout Stroika
						grahix - we had to change calls to GetOSRep () to PeekAt(), etc...
						Added View::BitBlit() override, since it needed to call Focus().
						Fixed up placement of scrollars inside of Scrollers.
						Fixed long standing ug with StandardMenu() where it sometimes
						would crap out in a MDEF proc call. I surmied tha was because we did a
						getresorce call once, and saved the handle. Rewrote so gets resource
						each time now.
						Added more careful seperation of Apple C/Cfront /Mac issues in Config.hh
						and supporting scripts (namely BuildFlags).
06/28/91	LGP			Gave up on new compilers, but used rest of new stuff. Changed exception stuff:
						made _this_catch_ a const pointer rather than a reference to a pointer, and
						made sCurrent private - use Exception::GetCurrent () instead.
						Worked on placement of scrollbars in scrollers, and the sizebox in
						windows. Better but not quite right. Really also should do native Window
						SizeBox which calls DrawGrowIcon (). Started Application busycursor support,
						and support in filebaseddocument for keeping files open.
06/27/91	LGP			Tried installing new compiler/cfront, and had trouble (MPW 3.2 Final buggy).
						Warmed over config.hh and buildflags to better support compiling with different
						compilers, and tried to sort out what are CFront bugs and what are C compiler
						bugs so we can use cfront with gcc, (or perhaps try cfront>ztc in text mode - just
						to get optimizations?). Tested if any compiler bugs fixed.
						Also, wamred over Strings abit to use Invariants instead of asserts for
						kBlackMagic (didnt do completely).
06/21/91	LGP			Added math support with backward compatabilty for sterls bad bad number support.
						May not be totally kosher yet, but thats mostly due to my weak understanding
						of SANE/IEEE floating point. Anyhow, nans seem reasonably well supported now.
						We can lift backward compatabilty in six months (old values for kBadNumber still
						in files out there).
						Also, fixed no arg FileException/MemoryExcption Raise () calls to see
						if they were the current exception, and if so, dont reset the error#. The
						result of that bug was that if you ever caught one of those exceptions, and
						re-propogated it with a _this_catch_->Raise (), you would loose the original
						error # that caused the trouble!
06/20/91	LGP			Tried/failed to fix bug with monitors cdev when running chms (offscreen gworld trouble).
						(try was to setgworld (maindevice) just before getnextevent). Also, tried
						and failed to make selectable::setselected flicker free. If I get that working,
						can change how adorment updating works (thats where the fix really belongs).
06/19/91	LGP			Did cursor/anim cursor resource support. Did quickie Quit/close docs support. Trouble
						with it is it does not take into account front to back order of windows...
06/11/91	LGP			Used excpetions in Document for cancelling closes, and got cancel of sfgetfile
						to work properly. Wokred around bug with #pragma force_active on which
						caused my ES patch not to work, and therefore crashes with the
						time manager when you es'ed out of macsbug. Started adding resfork support
						to filebaseddocument.
06/07/91	LGP			Reenabled deletion of cluts since I may have found bugs which caused their
						disabling before: call DisposeCLUT not DisposeHandle, and had sense
						wrong in a boolean test in PixelMap. Added safety checks on  adornment
						usage in View::SetAdornment ().
						Did minimal date support based partly on code from NIHCL.
06/06/91	LGP			Worked with sterl on getting offscreen tablet/gworld stuff working. Lots
						of trouble, but not works somewhat with a bunch of caveats. For instance
						when you run the monitors cdev with the app running, and change bitdepths
						it crashes in the finder. Probably only happens in CHMS since thats
						currently all that uses the offscreen tablet stuff.
06/03/91	LGP			Fixed bug with radiobank where it did not propogate buttonpressed. Added
						ability to enable/disable items in popupmenucontrol easily.
06/02/91	LGP			Added toupper/tolower to Strings. Added support to file for creating with optional
						mac creator and mac file type. Used this in PathNameSelector, and FileBasedDocument.
						Modified OldPathNameGetter_MacUI_Native etc's to all allow pathname filter
						on names shown. Used this is FileBasedDocument to filter out all but
						desired file type (namely kind creating - not always right, but good default
						behaviour and easy to override). Modified dialogeditor to take advantaget
						of all this, and provide a file type of 'TEXT', and a file filter, that
						looks for TEXT files ending in .dlg. All of these allow an optionkey press
						to override the restrictions.
05/30/91	LGP			Use qNative in Checkbox and RadioButton. Fix native versions of both (had fun
						using SADE to debug - worked well). Put SetFont (kSysFont) in dialogeditor
						main window, so layout works better, and fixup the dialogs there - bootstrap
						again, and fix fonts etc... Like to be able to use latest...
						Use dialogeditor to redefine filebaseddoc save dialog.
05/25/91	LGP			Hopefully fixed bug with cursors being set from time manager tasks (eg animated cursors), were
						cruft and other bad things could happen. Fix from Develop magazines Vol 2,1 Q&A. Use Hilight,
						not Invert in PickList (how about popupmenus - I think they always use invert?).
05/23/91	LGP			put in stroika vers resource (128). Also, add primitive chide alert for low
						memory situation instead of dropping into macsbug.
05/21/91	LGP			tried with -020 option and all seems to work fine - still must test on 68000
						to see proplery alerts and exits...
05/16/91	LGP			Added usage of #pragma 68000 to osinit, and osconfig so compiling with
						020 and running on 68000 should properly bring up alert, and exittoshell(untested).
						Also, use #pragma force_active instead of hack reference to globals to force them
						to be pulled in by linker. Did SetFont (system font) in dialog, and
						setfont of (applfont) in edittext, and setfont (nil) in statictext, so we
						get right defaults.
						Warmed over buildscripts so we can adjust link flags and trying 32bit everything.
						Also, put in header support for resouce based icons, pixelmaps, and pattern.
05/07/91	LGP			Added resource name, resourceID constructors for pictures. Used DetachResource.
						Should I have used Hand2Hand () instead?
05/07/91	LGP			Added version/bndl resource access functions to application, and used them
						to construct simpleAboutBox in user.c/h.
05/04/91	LGP			Added accessor to fileexcpetion object to see its error #. Patched in fixes
						from augment for file::Delete, and sliderbar (cleanup ui a bit).
						Added support to check in in forground or background in applicaiton.
						Did further tweek to view useage of iterators - directorly use right kind
						rather than indirect iterators...
04/28/91	LGP			Add set inclusion/equality/inequality tests. Added to sterls NullViewSequenceIterator
						stuff what may be a big optimization - checking for nil fsubviews even before
						constructing indirect iterators. Added predefined aboutbox command, and
						made system menu stuff use that rather than arguments to ctor.
						Added more ctors to pen/brush.
						Partially fixed Document/PathNameRetriever/File stuff to use current sfgetfile
						directory - only thing left to be done is test, and fix file.cc code.
04/27/91	LGP			Worked around main bug in 24 bit color qd - that bitmaps seemed to get
						screwed up when copied - by using memcpy () instead of bitblit to copy
						the image from pixmap to pixmap. Generally pretty close to ok workaround,
						but complex issue - bitblit should work - in a sense - but trouble is
						approximation of inverse table using current gdevice - and not knowing
						that cluts are equal...
04/19/91	LGP			Hardly touched Stroika in months. Hacked a bit more on TicTacToe game/sample
						program. Almost workable at this point....
						Minor touchup to EditText and added LabeledEditText, and changed
						Adornment stuff (all te changes related to this).
03/10/91	LGP			Did double link-list of malloced memory, and ValidateHeapStorage.
03/08/91	LGP			Tested / fixed up OutOfMemoryProc. Fixed exception usage in Application
						to use Match(), and generate dialogs.
02/27/91	LGP			Created classes PathNameSelecters, and implemented them for native SFGet/Putfiles.
						Still need to implement portable/MacUI versions - but close to that in
						AlXfer program. Work into proper subclasses of PathNameSelecters. Used
						these new classes in Document - and got rid of any dependence on non-portable
						stuff in FileBasedDocuement.
02/22/91	LGP			Add osconfiguration support for slotmgr (had to guess at right selectors-test!>.
						MPW headers/doc out of date. Also, added #define volatile to config.hh since
						latest MPW/c/cfront release doesn't suppport it.
02/21/91	LGP			Fixed View::TrackMovement to not track hidden view (eclipsed by other views).
						If window inactive, cut-off TrackMovement call. Added script to build
						nodebug version, and copyoff, and rebuild again...
02/20/91	LGP			Worked with sterl cleaning up bugs with new view optimization stuff. Also, lots
						of Documentation work.
02/14/91	LGP			Cleaned up include file dependencies by building with no loaddump. Finally
02/18/91				got file/PathName stuff in sufficiently good shape that I wont work on it
						for a while (I hope). Iterators (dir&volume) work, and most everything
						I've tried works. Not sure about pathnames relative to cwd, not sure about
						aliases, and lots of little utility things. See .cc/hh files for list of troubles.
						Important thing is I think enuf done for Augment project.
02/13/91	LGP			Cleanup osrename stuff, and add a few more entries - organize by file. Work
						more on PathName/iteration stuff. Enabled running Stroika apps on old systems,
						and check explicity in TimeManager support to see if its available.
						Also, allow non-32 bit color quickdraw when color quickdraw is present.
						All these changes must be tested!!!
02/11/91	LGP			Mostly worked on File iteration stuff, and tried out gcc. Trouble seems
02/12/91				to be gcc not compatable with new #pragma parameter guys in headers. Could
						either go back to old headers, or only compile files not using that stuff
						with gcc, or just wait. Did seem to generate much better code though.
02/09/91	LGP			Found work-around and thought of several expensive fixes to GetVisibleArea()
02/10/91				problem: workaround is to not override GetVisibleArea () in window, and
						then caching works, but then overlapping windows not taken into account.
						Starting to play with gcc, and see how that works.
02/06/91	LGP			Mostly worked on Focus optimization, and related caching stuff with View.
   -					Got little work done cuz of job hunting. Concentrated on profiling, and
02/08/91				performance. Lots of minor bug fixes and tweeks.
01/09/91	LGP			Mostly worked on documentation, and minor reworkings of Stroika to fit
	-					documentation better (i.e. got rid of many anamolies, etc). As of 2/4
02/05/91				Cognex project canceled, and were out lookin for more work, so Stroika
						development should pick up again.
01/08/91	LGP			Spent lots of time meeting at Cognex.  Worked more on scrolling textedit.
						Fixed conceptual error (in some places) about different between kZeroRect,
						and new Rect predicate 'Empty' which measures if it contains any bits.
						Implemented I/R/ndexOf(const String&).  Got Stroika printout, and made lots
						of misc cleanups.  Thinking about redisplay bug with SyncOsWindows.  Fixed
						Sequence stuff to use SequenceIndex, rather than UInt32.
						That was causing trouble in scrollers, and probably elsewhere.
01/04/91	LGP			Did ScrollableTextEdit.  Did interface for Colorizing icons.  Fixed Command/
   -					stuff with EditText (now cut/paste works).  Tried to get %. working in dlogs.
01/06/91				Got autoscrolling, and scrolltoselected working pretty well for ScrollableTextEdit.
						Tried to fixup .hh file dependencies.
01/03/91	LGP			Worked more on textedit, and scrolling.  Fixed lbrace/rbrace.  Added
						I/R/ndexOf(const String&) to string header (no impl).  Integrated with sterl.
01/02/91	LGP			Went to cognex.
01/01/91	LGP			Happy new year.  Tweeked TextEdit drawing to get rid of flicker, and
						added hook to be called on change of destrect so we can fix the
						scrollbars.
12/29/90	LGP			Basically done with PopupMenuControl, except for funny bug where we must
						call setclip (GetVisibleArea()) (thought that was fixed), and
						for some reason popup comes up with funny thing selected?
						TearOffMenus working, and so are PalleteMenus.  A few things left todo,
						but looks pretty good.
12/28/90	LGP			Moved fVisible to Panel, and overide View::GetVisibleArea() in Window
						to use visRgn.
12/27/90	LGP			Working on TearOffMenus, PopUpMenus, and TearOffPaletteMenus.  Got each
						at least partly working.
						Earlier - got rid of SetClip hacks - did cut at Focus stuff in view which
						made them obsolete.
12/23/90	LGP			Did performance analysis, and say region stuff taking hugh amount of time.
						Added qUseRgnLList (avoid calls to NewRgn/FreeRgn) hack and had dramatic
						improvment.  Still could use lots of work on this count though.
						DID MORE TRAP CACHING IN TABLET AND WINDOW.  STILL COULD FIXUP WINDOW::UPDATE more...
						Upped calls to ::MoreMasters (); since heap stuff was at top of perfromance list.
						Performance is quite noticably better.
						On CI, got gridpallete working just like did on Onsight.  Looks PERFECT.
						Need to do tear-off support, and in-menu tracking still.
12/22/90	LGP			Rebuilt with loaddump off, and fixed header include troubles.  Got to work
						with sade (with no load dump - must play further).
						Changed support in Document for changecount and used that for dirty
						notion in filebaseddocument.  Also, added command which can just be
						posted, and it automatically takes care of dirting, and cleaning up document.
						Put button stuff back to the design sterl had, and fixed native pushbuttons
						to work that way (UNTESTED).  Added just enuf support for focus in View
						to be able to get rid of SetClip hacks which had prolifered stroika.  Also,
						some efficiency hacks.
12/18/90	LGP			Finally got View::GetVisibleArea () right (I hope - Fixed trouble in dlogeditor with sterl).
    -					Moved Panel.cc to Framework and StreamUtils to Foundation.  Added GetRegion ()
12/19/90				to Panel.cc (uses shape&bounds).  Renamed PaintShape, etc.. to Paint (got rid
						of redundent shape word).  Also, added View::Fill() - like paint but takes
						tile instead of brush and uses copy).  Window overrides setbackground to
						set backpat of grafport(buggy-disabled).  Wrote inserters and extractors for ByteArray, Picture,
						Color, and ColorLookupTable - still todo - PixelMap.
						Made inserter/extractor for PixelMap, Some troubles with op= for pixelmap.
						Set hysteresis to zero, time to zero for window tracker (like tobe more like mac).
						Fixed use of assertions in ReadString (set error state in stream instead).
						Use native pushbuttons by default.
12/17/90	LGP			View did not take into account visibilty.  It does now.  (althogh perhaps
						not perfectly still).  Also, commented the code in View.cc better.
12/16/90	LGP			Fixed scrollbits usage in scrollers to work right.  PickLists look pretty good
						but must tweek API a bit (add functionality, and View-based interface).
						Cleanedup doc dlog (til get dlog editor).  Got picture button working.
						Fixed bug in Realloc/Malloc stuff for MPW when compiled with debug off (think
						MPW lib bug - realloc (size=0) doesnpt work well).
12/15/90	LGP			PickList.  Got rid of Collection(T)::Updated () - decided it wasn't going
						to work well enuf to justify the expense.  Also, moved some collection things
						out-of-line since running into compiler bug where it doesn't generate
						vtables.  ARG!
12/14/90	LGP			Fixed AnimatedCursor bug that only showed-up with new compiler (my bug).
						Fixed subtle bug in View::ProcessLayout () where its caching info got
						outofdate, and would never call someones layout.
						Refresh with no region specified uses GetVisibleArea (), rather than
						GetLocalExtent(). This will avoid redrawing other views unnessesarily (eg.
						in scrollers).  Did no-debug,no mbug-syms,opt,020 build and everything crahsed
						early.  Didling other params will take time. Got picklists working (needs interface
						cleanup, and more params to adjust).
12/13/90	LGP			Got things working with new compiler, and integrated with sterl.
12/12/90	LGP			Started work on PickList.  Made tile stuff a bit more typesafe.  Did
						tablet::scrollrect ().  Updated todo list, and organized better.
12/11/90	LGP			Got scrollers working pretty well, except for scrollbits support (since must
						be very careful about aligning patters), and properly alinging sbars, since
						a royal pain, and quite usable now. Fix Dialogs to save dismisser.  Fix
						PalletView to shutoff old view before turing on new one.
						Added new GrayShape() methods to view (ala InvertShape), and for each
						simple op added no-arg version (eg. View::Invert ()) to apply to whole
						view (with its shape) since used so often.
12/10/90	LGP			Worked on scrollers, and used the in clipboard window view, and textedit example.
12/09/90	LGP			Got cut-n-paste framework support working pretty well now.  Window updates
						automatically, convert clip multifinder messages are processed, and PrivateScraps
						all work, and are implemented for TextEdit.  Main thing left to do is routines
						to access what types available in clip better, and to support undoable clip operations.
						Havent done private scrap for DialogEditor, but may tonight if time permits.
						Also, put insersion/extractors for a few types (Rect, Point, etc... in).
12/08/90	LGP			Got cut-n-paste working in dialog editor (still needs lots of work).  Also,
						added document support (again just rough outline).  Fixed bug with clipboardwindow in
						application - hide on application-object destruction.
12/07/90	LGP			Added textedit application, and fixed bug with recursive doit calls from
						Application::RunOnce ().  Also, fixed (hopefully) once problem with
						activates, that is makeing them highest priority events should get rid of
						some flicker.
12/06/90	LGP			Finished testing new MPW stuff.  Worked more on clipboard.  Integrated with sterl.
12/05/90	LGP			Worked more on Pictures and got them working enuf to make headway on ClipBoard
						stuff.  Got most of the clipboard window support done.
						Got new version of MPW (2.0b1) and (cfront 1.0b4).  Doc claims fixes vbase
						class bugs, but this is not the first - not even 10 time thats been claimed!
						Will try.
12/04/90	LGP			Implemented keyboard support, and updated keyboard record for state at
						time of event, in EventManager.  Started work on Pictures, and Picture
						Tablets.  Related is offscreen tablet stuff so working on that too.
12/03/90	LGP			Worked with sterling on dlogs, and worked at home on clipboard.
11/30/90	LGP			Started clipboard support.
11/29/90	LGP			Fixed bug in Sequence::IndexOfSequence (Seq&).  Major reworking of file stuff
						again!  Got the file stuff and stream stuff working well enuf to fully support
						documents, but broke everything else that used to work with files. Boo!
11/28/90	LGP			Did first cut at document support.  Looks pretty good, but now I must
						bite the bullet, and finish the file support.  ARG!
11/27/90	LGP			Finished work on menus.  Much faster.  System menu enable/disable now works
						properly.  Moved G/SetName/Accelerator/Marks to AbstractMenu, and added
						command accessors to MenuOwner, and MenuCommandHandler to make for easier
						usage.  Added PeriodTask/Idle Task support, and used it in application.
						Reworked EventHandler stuff to support idle events, and application to
						manager idle tasks.  Also, changed when certain event loop things happen.
						Still needs more work.  Did dispose of windows in destructor for windowcontroller.
						Should be reasoanable default behaviour, but still need to to document
						support, and have docs do something before they get destroyed when
						they know their being closed....  Added blinker idle task to textedit, and
						works pretty well, unless cursor goes outside window.  I suspect the trouble
						has to do with the parameter we are giving to WNE.  We must compute this
						based on the idle task periodicities, or something like that.  Also, TE
						invals menus as necessary.  Next big thing to do there is commands, and undo.
11/25/90	LGP			Patched ExitToShell trap, so it calls exit().  Then, re-enabled time-manager
						stuff.  Only point of patch is so sterl can say 'es' in macsbug.
						Added .r files to makefiles, for each application, and made default .r
						files for each, with icon, and proper SIZE() resources.  This was needed
						to fix bug where apps where not getting mouseMoved events.  Also to mouseMoved
						bug, signed/unsigned trouble in >> in Event.cc.  Did much performance
						improvment on menu stuff.  Did NullMenuProc, and hash-table for caching
						location of commands.  Did shortcut on resetall: just directly set
						enableFlags to 0.  Still much more todo here, but down to < .1 second.
						Much cleanup needed.
11/24/90	LGP			Fixed SetOrigin bug on Window::InvalRgn.  Also refined Window::Update() logic.
						Got rid of Tablet::Save/Restore port setup. Do manually in each case.  Now
						easier since we make no promise to restore.  Hope thats safe approach!!!
11/13/90	LGP			CELEBRATION TIME!!! FOULD COPYPIXPAT BUG!!! DON'T USE WMGRPORT, MAKE OUR OWN!
						Sort of knew that was true, but never got around to it before! Tested and works!
						Had trouble getting native controls working with color, but bug appears
						to be in colorQD 2.0!  It creates windows with Nil pnPixPat, and then
						::GetPenState () crashes in that case.  Workaround easy, but gross.  Also,
						must test other QD version to be sure.  started to make macCTL subclass of view,
						to get code sharing.
11/12/90	LGP			Hacked a bit at sbars, and had no luck.  So tried cleaning up color stuff.
						Worked on CLUT stuff.  Put in interface to inverse table stuff (sloppy but workable).
						Also, noticed I was indexing wrongly.  That could have been serious?  ctSize
						has bizarre interpretation (0 value => 1 color!).
						Started getting rid of redundent data in pixelmap, but dangerous, and
						so taking slowly.  Also, must test clut change.  Changes worked, but much more
						todo on low level graphix support. Also, hacked SetClip in Tablet so desktop hack
						would work - fix right tommorrow by keeping notion of current tablet...
11/10/90	LGP			Got native sbars working better, and got native buttons done.  All that stuff
   --					still needs lots of work in the code-sharing dept, but hard without vbase
11/11/90				classes.  Progressing nicely on port-save-info approach.  Almost right I think.
						More cleanups on removing activeitems so we can close docs safefly, and
						updating test to be able to multiply open and close the various kinds of
						docs to test.
						Debugged spooky problem with color windows and native scrollbars.   I think
						the macapp hack doesnt work with color windows and color controls. I suspect
						the problem has to do with the maintainance of the AuxCtl structures.  Will
						need new hack to make native controls work, but for now, just pretend
						not coloravailable, and use old style windows.
11/08/90	LGP			Implemented View::GetVisibleArea(), and used that for clipping in textedit
   --					stuff.  WOW, much better than old zeno support.  Now with regions right
11/09/90				stuff like mac TE clips right against sizebox.  Bet that never worked before!
11/07/90	LGP			Figured out why sbars broke - had to do with re-enabling my Color QD hacks.
						So for time being, disabled it in OSConfig.  Needs much work (1 manweek)
						revisiting, and reworking.  For now, get native controls working right.
						And must fix adornment, buttons, and all other stuff sterl and I broke.
11/06/90	LGP			Worked on lots of little things trying to get stuff working again.
   --					Created 'Small' application.  Changed Collection stuff to use const T for
11/02/90				things such as Includes().  Ran into mucho vbase class bugs, trying to
						get new activeitem stuff to work.  Got things partially working again.  Also,
						got system 7.0b1.  Works nicely.
11/02/90	LGP/SSW		We worked together today, and re-implemented AdornView.  Designed and
						implemented ActiveItem, and EnableItem.  Reworked most controls so
						hierachy supports mac/native, etc.. modes.  All this needs lots of work,
						and is only barely started.  Stuff badly broken at this point.  Lots tado.
11/01/90	LGP			worked a bit more on macnative scrollbars, and they work except for hilite
						states (need to think out activation - sterl and I may have worked out
						solution in car).  And leaves port in bad state for future draws.  That
						needs to be fixed soon.  Really rework hacks so more safe and re-usable
						for other controls.
10/30/90	LGP			Typed in VERY prelim cut at ScrollBar_MacUI_Native, and got as far as
						actaully drawing right!!!  Think I've guessed problem I ran into many
						moons ago disposing ctls (though I havent tested yet) which is you must
						put them into a fake window, AND make them invisible, so we dont try
						to draw them.  GROSS.  But I hope that does work.
10/29/90	LGP			Started key handler support.  Use %p instead of 0x%lx for pointers and size_t.
						Not sure if right for size_t?  Work more on textedit, using key stuff, and
						getting its menu commands working.
10/28/90	LGP			Did quickie implementation of textedit.  Looks pretty good, though still
						need to support keys, and scolling, cut/paste, and a few others.  Also, need
						to work out who calls TEActivate, etc... Current window activate bugs
						annoyiung.  Must fix soon.
10/18/90	LGP			Got array working.  Found two compiler/lib bugs with turbo c++ (1), operator
						new of array of objects with UInt32 produces bad crash.  Cast to size_t as
						workaround.  Also, malloc (0) produces bad results (workaround -- add 1).
						TODO soon is patch exception stuff to not pass value as longjmp arg, and
						intead use global.  That should get exceptions working.  Then, really done
						til we have file support in stroika for mac, and have written translator,
						and also we need zortech, so we can do MS Windows (needed for next layer -
						graphix!).  Implemented exception fix and tested on mac.  Still must test
						on PC.
10/17/90	LGP			Got a few files (strings,ecxception,test_str,test_exe,array,tst_array++) ported
						to MSDOS, with TURBO C++.  Not all worked, and its been much harder than I'd
						like to admit.  My memory of DROSS had faded.  Most bugs had to do with
						casting ptrs to ints, in hidden ways.  Not all is checked in on mac yet, and
						still some work todo with these, but comming along.
10/16/90	LGP			Worked a few more hours on the file support.  About to kill myself, as it
						still does not quite work.  What a morass!
10/11/90	LGP			Work alot (apx 12hrs) on file support and put test into testwuite(got testsuite
						working again).  Also made attempt to fix flicker in titlebar, and made things
						worse (hopefully made some progress though).   Made attempt to port some
						foundation stuff to PC (TurboC++) and had little success.  Will take several
						days to just get low level of test suite stuff working.
10/09/90	LGP			Added Stroika.hh, and Stroika-Globals.hh to Lib directory (Just include
						User versions - seemed to crockish to include directly).  Also, changed
						makefiles to support new dir in path.  Got TestSuite working again, and
						updated all makefiles accordingly.  Added void	Sequence(T)::SetSize (UInt32 newSize, T fillInWith).
						Made it nonvirtual so smart linker can elim, though very inefficent since
						subclasses could be more smart.  Ah well.
						Fixed const violation with exception stuff.
10/05/90	LGP			Changed scripts to support tags.  Works pretty well.  Should help people
						to learn stroika. Threw in paranoia checking in tablet/window to be sure
						low level managers inited (peek at their global var - maybe not safe, but
						just an assert).  Added resumeproc code to eventmanager - though not tested...
						Did a little trap caching in Tablet.cc, and some performance tweeks.  Still
						much less than half done there, though.  Thats a key bottleneck.
10/04/90	LGP			Made OSGrafPtr() stuff more typesafe in tablet.  Also, same for other graphix
						types.  Did trap caching in Region.cc.
						Added Region Tablet::GetBounds ();  Also, Tablet::GetBounds ().
10/02/90	LGP			Got UserDefinedMenu stuff work, (ie menuView) in Test.c.  Got pixelmapbutton
						to appear in a menu.  Added some oscvt support, namely directly into Point
						& Rect .hh.  Seems reasonable, but not sure right final solution.   Added
						CustomMenu.cc to User, and put MenuView (RENAMED) in there.  Also, hacked
						palette menu into DLogEditor, to see what it looked like (need to rebuild).
09/28/90	LGP			Worked at sterls house, and did clipping in views.  Then,
						at home did further work on tear-off menus (so far we
						use mdef procs).  Found CFront bug bothering sterl with
						strings:
							Construct static object in funct scope with arg requiring
						dtor.  Gets constructed on first time thru funct when
						obj created, but temporary gets destructed at end of
						proc regardless of whether ctored.  Bug showed self lots
						of times, but in particular in PushButton.cc with
						font name "chigago" as arg to static Font ctor.
09/27/90	LGP			Fixed makefiles, to make them more independent of full pathnames.
						All SB OK, so long as you dont have spaces in names (use '_'), and
						do makedepends from the top level project.  Also, I THINK I found
						the bug that was causing all sterls crashes.  He just passed bad cluts
						when constructing some pixelmaps.  I've added more Requires to catch
						such mistakes.  Make have also been my mysterious CopyPixPat bug?.
						Made DebugMenu () in charge of implementing all reactions to debug menu
						entries (for encapsulation sake).  Made window closes go thru windowcontroller.
						Moved palettview into User, and about to try using USER for first time!
						Adding things above each layer (eg Stroika.dump) so we dont count on name
						of highest level - since that just changed!.
09/26/90	LGP			Added low memory support/cheesebuf (mostly debugged).  Still need
						to work on dialog when out of cheesebuf, and put into idle task.
						Added a bit to printmemorystatistics, and updated Application to enable/do the
						command.
09/22/90	LGP			Fixed bug in AdornView::SetAdorn about about exactly is
						the region to get updated.  Must take max of old drawn
						extent and new.  Talk to sterl to see if this bug happens
						elsewhere.  Moved get/set visible from window to view.
						Added View::GetEffectiveVisible () and Region View::GetVisibleArea ().
						Made Button::DrawOnState () use InvertShape rather than HilightShape ()
						since that seems to be what most mac (all that I've seen) seem to do.
						It may be that I'm looking at the wrong butons?  We need to discuss 
						the meaining of HilightShape().
						Put in Performace testing support.
						From PushButton::CTOR://	static	String	kChicago = "Chicago";	// LEWIS: note old bug workaround, explain please!!
						I pulled it out, and seems to work fine?
						Tried to test performance stuff.  It worked fine.  Used it on menu problems,
						and did slight tweeks to window activation/gApp->SetMenusOutOfDate (),
						and as far as I can tell - at least for now - menus are fine.  No tweeks
						necessary.
09/21/90	LGP			Add at param to Tablet::textwidth (optional).  Reorder params to Tablet::DrawText ();
						Get rid of PixelMapShape.  Only used in ScaledShapeButton,
						but that was unsafe.  I think ScaledShapeButton should die too.
						Added PixelMapShape class which seems to be all thats really
						needed for now, and works better than old system (adds
						new flag to choose if you want to scale).
						Talk to sterl about remembering who is responsible for deleteing
						what.  His use of shapes/SetShape is VERY unsafe/Broken.
						Put partial fix in Panel, but that stuff scares me.  Be sure
						ONLY HEAP BASED Shapes handled to SetShape.
						Just noticing how much panel is like zeno TabletOwner.
						Sterl didnt like that as I recall.  Maybe just didnt like
						name.  Mention it anyhow..
						Didn't like unsafe use of Region(void*).  Rethink, and
						perhaps change const Region (const void*).  Safer, and
						any performance benifits of the former can be
						achieved thru friendship.
						Added Clipping Region support to Tablet/Panel.
						Lots of work on CLUT/PixMap stuff.  Hope I havent broken
						anything :-).  TODO, get rid of redundent representations
						of things like rowbytes, baseAddr, and boundsRect.
						Made lots of things const member functions in rect/Panel, etc...
						that should have been before.
						Panel::GetShape () now returns const (and all things that called it
						to return shapes).
09/19/90	LGP			GOD NO WORK FOR 1 MONTH!!!  RENAMING PROJECT TO STROIKA - LONG LIVE
						STROIKA!!!!!!  Major reworking of MPW scripts and stroika file
						organization.  Added User Level, and perhaps soon new os support.
08/19/90	LGP			Did trap patching in Menu, and got some improvement, but not nearly
						enuf.
08/19/90	LGP			Added primitive check item support and fixed up menus a bit, tho
						thier pretty slow now (sorry).  Did a bit more on the DLogEditor,
						mostly just using the menu stuff.  Do general  selectitem/etc stuff
						next when in arrow mode.
08/18/90	LGP			Worked on DialogEditor mostly.  Ran into infamous vbase class bugs
						with adornview.  Ah well.  Also, funny bug.  Attempt to
						call DLogItem::Layout () wrote as DLogItem:Layout()!!!!!!  Unused
						label and infinite recurse!  Got corners on DITLs and have PB kind.
						SB easy to allow resize (do next).  Then add menus to chose item
						kinds, and other options.  Then do file IO.
08/17/90	LGP			Cleaned up project stuff some more.  Created DialogEditor project,
						and made a little headway on that.  Trackers seem still pretty
						broken, or at least I need some explanation of how to use them.
						ALSO, disabled Time Manager Support, since it seemed to be causing
						sporadic crashes (not sure that was it, but we'll see).  MUST be
						able to disable it on exit, eg with trap patch.
08/16/90	LGP			After a long haitus, finally back to work on Zeno.  Reworked
						project stuff significantly, moving test app stuff out, and building
						higher level project.  Also, cross project projector stuff now
						works much more nicely.  Be sure Sterl gets all new scripts.
						Also, very careful on the merge, since projector stuff will be
						uncompatable (largely).  Also, find stuff should now
						work flawlessly.  Does on my machine anyhow.  Let me know sterl!
						Also, added MainViewWindow, and TitledWindow, and ScrollerWindow,
						and partially deleted DocuementWindow.  Really not implemented, but
						files are there.
08/09/90	LGP			Merged.  Added first cut at TextBox (tho needs much thought).
						Made more appl additions to support dosetupmenus, etc. but
						that still needs much work.
08/08/90	LGP			Did more work on target chain stuff, adding CommandHandler class, and
						MenuCommandHandler.   Avoid stepping on sterls toes for today, but
						tommorrow do MainViewWindow, etc.. and use this to make target
						chain stuff right.  VERY HIGH PRIORITY.
08/08/90	LGP			Moved some paint/outline shape wrappers into panel from view, though
						made virtual (possibly shouldnt be), and done differently there(again,
						probably shouldnt be).   Also, overloaded these and related functs
						in View, to take ScaledShapes, and put in as the bounds
						the LogicalSize() of the ScaledShape, thus making use of things
						like lines and bitmap shapes terser.<Havent tried simplifying things
						yet since sterl maybe touching those files - try tommorrow>.
08/07/90	LGP			Added PixelMapEditor class to top level since we have no user level
						stuff yet.  Once we get more to put there, build such a layer.
08/07/90	LGP			Added X(const X&) args to Sequence_Array(T), and op=.  Have neat
						property that now you can just say array x = y, to copy whole
						sequences!!!
08/07/90	LGP			Put in a bunch of private X(const X&), and op=(X&) guys in .h, but
						not in .c, since never called, just to prevent someone from
						doing View v = *button, or something stupid like that.  Did for Foundation,
						and grafix classes where appropriate (generally anything with
						a pointer to really stuff inside).  Could also go more in that
						Framework, but not much point since they are inherited (well op= is,
						and X(constX&) propogates cuz of rules for autogen of subclass versions).

08/07/90	LGP			Made Collection(T)::MakeIterator() const, etc...  Mixed bag.  Causes
						const violation in implement of seq_arr, and set_bitstring, in
						keeping linked list of iterators over a collection.  Conceptually,
						making an interator sb const, its only an impl. detail that it is not
						really (thats my justification).  Other choice I had was to allways
						pass around Collection(T)&, rather than const Collection(T)&.  That
						way I could avoid what I had - lots of sporadic const violation errors.
						Not sure what best way out of this mess is.
08/06/90	LGP			Made Rect(const Rect&) defined, rather than auto-inlined since
						wasnt getting inlined anyhow, and would be several instructions.
						Similarly for op=.  Added GetTablet () pure virt method to
						Panel, and move LocalToTablet and back stuff from view to panel.
						Made requisite changes to windowplane, view, and desktop to support
						this.  Then, got rid of UpdateCurrent  () from collection iterator,
						and all the generic subclasses, since it does not make sense for
						Sets (and therefore not for collections).  It might for Sequences,
						but I deleted it there too since appeared no need.  Might rethink
						later.  Also, moving toward making makeIterator guys const!!!
08/06/90	LGP			Just got back from vacation, and first build. In interum, sterl
						did some work with controls, and implemented nearly all of generic
						mac controls (except sbar).
07/19/90	LGP			Fixed minor TM bug.  AnimCursor/TM seem to work fine, and TM now
						runs at intervals appropriate for its Q elts.  Integration with
						Sterl, and minor header cleanups.  ON VACATION TO ENGLAND!!!
07/18/90	LGP			Redid Time class from scratch.  Hopefully right, but untested (now
						exhaustively tested for 1 case).  Added more time support to
						time mgr, and animated cursor stuff.  about to test.
07/17/90	LGP			Got a bit of tasks/time manager stuff working, and did AnimatedCursor.
						Really Neat - derezed globe cursor, and stuck that in test.
07/16/90	LGP			Finally got Set_BitString working (for fonts), the extended
						support for iterators and negative numbers (tested-fine).
						Built and tested no-debug, no mbg symbols version on sys 6.0.? MacPlus,
						and worked fine (though window came up in bad place by default).
07/15/90	LGP			Wrote Set/Set_BitString, and tried it in Font (for styles).
						Still half-assed implementation with no iterators, and
						only sets of int 1..n.  But should be easy to improve.
						Also, do general setofobject SOON, using arrays or linkedlists.
07/13/90	LGP			Wrote BitString.  Couldnt test since I deleted makefiles!
						Ugg! Stipid!  Started writing idletask, etc task stuff.
07/09/90	LGP			Menus: moved some MenuBar stuff to MenuOwner; added enable/
						disable by CmdNum methods.  Got enuf working to get DAs (under
						MF) working.  Changed String::Length () to GetLength().  Added
						cmdkey equivs.
07/08/90	LGP			Got enuf of menus done to be useable.  Only important bit
						of interface left to do is enable/disable by CmdNum.
07/07/90	LGP			Actulally got menu stuff working, a bit.  And added copytright
						notices, and bringAppToFront () function to Application.
						Added DebugMenu.  Added ArrayOfPointers to save obj file space.
						Did builds and saves of no-debug/nombg syms, and looked at
						DumpObj of Zeno.o.  Added Sequence_ArrayOfPointers and
						replaced all appropriate occurences.  With debug/mbg on, seemed
						to save about 1K/PT Instance.  Added a bit more to menus, to make them usable.
07/06/90	LGP			Fixed font stuff a bit, and added a bit more menu functionality.
						Menu stuff E5% done, E50% way to having something usable.
						For some reason got spooky bug though.  And been having
						BAD linker crashes?  And added start at hilitemode/arithmetic
						mode copies.  Needs lots more thought, esp wrt. portability.
07/03/90	LGP			Added Updated () method to Collection(T) so we have one
						place to override to catch all collection updates.  Not
						sure EXACTLY how to gaurentee easily always called ONCE.
						Also, did primitve cut at menu support.
06/30/90	LGP			Finished View Pen/Brush/Font saving.  Did font interators
						(half assed), and get font # for drawing. Changed TextOut
						from array of char to Zeno String.  Did default backgound
						stuff, and EraseShape ().
06/30/90	LGP			Started adding View Pen/Brush/Font saving.  Almost done.
06/29/90	LGP			Merged Implements layer into Foundation
						Fixed bug where fill/outlines did not work on plus (cuz
						need |0x8 in ::PenMode()).   Added Cursors.cc.  Moved
						EventManager from Foundation to Framework.  Worked a bit
						on Get/SetPixel in PixelMap (close to general alg - needs
						thought).  Did more better tests in Test.cc for pixel/tile
						stuff (really seems to work).
06/29/90	LGP			First created log.

// For gnuemacs:
// Local Variables: ***
// mode:Text ***
// tab-width:4 ***
// End: ***
